//
//  NSView+Additions.h
//  MPServices
//
//  Created by Oleksii Dykan on 27/08/2014.
//  Copyright (c) 2014 MacPhun. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "NSBezierPath+Additions.h"


@interface NSView (Additions)

@property (nonatomic, assign) CGPoint center;

+ (instancetype)loadFromXib;
+ (instancetype)loadFromXibNamed:(NSString*)name;

- (void)fixSublayersPositions;
- (void)roundedCorners:(MPBezierPathCorner)corners cornerRadius:(CGFloat)cornerRadius;
- (BOOL)isSubviewOf:(NSView *)view;
- (NSArray<NSView*>*)allChildrenContainingPoint:(NSPoint)location;

@end
